package electionSimulator;
import java.util.ArrayList;

/**
 * Given a list of States, simulates a presidential election.
 * 
 * @author Curt Clifton. Created Sep 23, 2008.
 * Modified by David Mutchler
 */
public class ElectionSimulator {

	private ArrayList<State> states;

	/**
	 * Constructs an election simulator for the given list of states.
	 * 
	 * @param states List of states for which to simulate an election.
	 */
	public ElectionSimulator(ArrayList<State> states) {
		this.states = states;
	}

	/**
	 * Runs a simulated election multiple times. Calculates the number of
	 * electoral votes won by candidate A in each trial. Returns an array where
	 * the array index is the number of electoral votes and the value is the
	 * estimated probability of a simulated election yielding that many
	 * electoral votes for candidate A.
	 * 
	 * For example, suppose the return value was stored in a variable "result",
	 * then result[270] would give the probably that candidate A wins exactly
	 * 270 electoral votes in a single simulated election.
	 * 
	 * @param trials the number of simulated elections to run,
	 *               a larger number should yield better estimates
	 * 
	 * @return an array giving the probability of candidate A winning any given
	 *         number of electoral votes
	 */
	public double[] runSimulations(int trials) {
		// TODO: implement this method
		return null;
	}

	/**
	 * Runs a single simulation and returns the number of electoral votes earned
	 * by candidate A.
	 * 
	 * @return number of electoral votes earned by candidate A
	 */
	protected int runSimulation() {
		// TODO: implement this method - loop over the states,
		// simulating each one and summing the electoral votes earned by A
		return 0;
	}

	/**
	 * Returns the total number of electoral votes of all the states
	 * in this simulation.
	 * 
	 * @return the total number of electoral votes of all the states
	 * in this simulation.
	 */
	protected int getTotalElectoralVotes() {
		// TODO: implement this method - sum over all the states
		return 0;
	}
}
