package electionSimulator;
import java.util.ArrayList;
import java.util.Scanner;

/**
 * This program simulates a US presidential election. It's inspired by the
 * analysis at fivethirtyeight.com, but is less detailed.
 * 
 * @author Curt Clifton. Created Sep 23, 2008.
 * Modified by David Mutchler, April 2009.
 */
public class ElectionSimulatorMain {

	private static final int TRIALS_TO_RUN = 10000;

	/**
	 * Number of stars in text output to indicate a probability of 1.0.
	 */
	private static final int MAX_STARS = 50;

	/**
	 * Runs the simulation.
	 * 
	 * @param args Command-line arguments, ignored here
	 */
	public static void main(String[] args) {
		// TODO: Get state data from (for example) DataFromSept22 class.

		// TODO: Create simulator object and run TRIALS_TO_RUN sample elections.

		// TODO: Display results, by calling the displayResults method
		// and giving it the probability array returned from the simulation.
	}

	/**
	 * Displays a bar chart showing the probability of candidate A winning all
	 * the various electoral vote values.
	 * 
	 * @param probA a probability array as returned by
	 *            {@link ElectionSimulator#runSimulations(int)}
	 */
	public static void displayResults(double[] probA) {
		ElectionSimulatorMain.printHistogram(probA);
		
		// TODO: Print the probability that candidate A wins;
		// use the method that you create below to perform the calculation.
		
		// TODO: Print the probability that candidate B wins;
		// use the method that you create below to perform the calculation.
		
		// TODO: Print the probability that the election is a tie.
	}
	
	/*
	 * TODO: implement a method that takes an array of doubles
	 * and two indices j and k,
	 * and returns the sum of the numbers in the array from j to k,
	 * including the entry at j but NOT including the entry at k.
	 */

	private static void printHistogram(double[] probA)  {
		double max = 0.0;
		
		// TODO: Compute max = the maximum probability in the probA array,
		//       so that we can normalize the results
		
		
		for (int i = 0; i < probA.length; i++) {
			if (i == 1 + probA.length / 2) {
				for (int j = 0; j < MAX_STARS + 5; j++) {
					System.out.print("-");
				}
				System.out.println();
			}
			System.out.printf("%3d: ", i);
			int numberOfStars = (int) (probA[i] / max * MAX_STARS);
			for (int j = 0; j < numberOfStars; j++) {
				System.out.print("*");
			}
			System.out.println();
		}
	}


	/**
	 * Using the given scanner object, prompts the user for the data needed to
	 * create a new State object. Returns null if user says they are done.
	 * 
	 * @param scanner Object from which to read
	 * @return a new State object or null
	 */
	public static State getStateFromUser(Scanner scanner) {
		System.out.println();
		System.out.println("__ State _____________________________");
		System.out.print("State name (or just enter when done):");
		String stateName = scanner.nextLine().trim();
		if (stateName.equals("")) {
			return null;
		}
		System.out.print("                     Electoral votes:");
		int eVotes = scanner.nextInt();
		System.out.print("          Candidate A odds (0.0-1.0):");
		double aOdds = scanner.nextDouble();
		System.out.print("          Candidate B odds (0.0-1.0):");
		double bOdds = scanner.nextDouble();
		/*
		 * Consumes the enter key after the last double so it doesn't show up
		 * when we try to read the next state info.
		 */
		scanner.nextLine();
		return new State(stateName, eVotes, aOdds, bOdds);
	}
}
