package electionSimulator;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

/**
 * Tests the State class.
 * 
 * @author Curt Clifton. Created Sep 23, 2008.
 */
public class StateTest {

	/**
	 * Test method for {@link State#simulate()}
	 */
	@Test
	public void testSimulate() {
		State indiana = new State("Indiana", 11, .484, .497);
		State redland = new State("Redland", 1, 1.0, 0.0);
		State blueland = new State("Blueland", 1, 0.0, 1.0);

		int votes = redland.simulate();
		assertEquals(1, votes);

		votes = blueland.simulate();
		assertEquals(-1, votes);
		
		/*
		 * CONSIDER: since simulate() returns a random value, we have a variety
		 * of possible outcomes that make sense. The distribution of results is
		 * tested by ElectionSimulatorTest, so here we just do a sanity check.
		 */
		votes = indiana.simulate();
		assertTrue(votes == -11 || votes == 0 || votes == 11);
	}
}
